import { login, logout, getInfo, login2, fulllogin } from '@/api/user'
import { getToken, setToken, removeToken } from '@/utils/auth'
import { resetRouter } from '@/router'

const getDefaultState = () => {
  return {
    token: getToken(),
    name: '',
    avatar: '',
    perms: []
  }
}

const state = getDefaultState()

const mutations = {
  RESET_STATE: (state) => {
    Object.assign(state, getDefaultState())
  },
  SET_TOKEN: (state, token) => {
    state.token = token
  },
  SET_NAME: (state, name) => {
    state.name = name
  },
  SET_AVATAR: (state, avatar) => {
    state.avatar = avatar
  },
  SET_PERMS: (state, perms) => {
    state.perms = perms
  },
  SET_DEPT: (state, dept) => {
    state.dept = dept
  }
}

const actions = {
  // user login
  login({ commit }, userInfo) {
    const { username, password } = userInfo
    return new Promise((resolve, reject) => {
      login({ username: username.trim(), password: password }).then(response => {
        const { data } = response
        commit('SET_TOKEN', data.access)
        setToken(data.access)
        resolve()
    
      }).catch(error => {
        reject(error)
      })
    })
  },
  fulllogin({ commit }, userInfo) {
    const { username, password } = userInfo
    return new Promise((resolve, reject) => {
      fulllogin({ username: username.trim(), password: password }).then(response => {
        const { data } = response
        commit('SET_TOKEN', data.access)
        setToken(data.access)
        if (!data.user) {
          reject('验证失败,重新登录.')
        }

        const { perms, name, avatar } = data.user

        // perms must be a non-empty array
        if (!perms || perms.length <= 0) {
          reject('没有任何权限!')
        }
        
        commit('SET_PERMS', perms)
        commit('SET_NAME', name)
        commit('SET_AVATAR', avatar)
        resolve()
    
      }).catch(error => {
        reject(error)
      })
    })
  },
// user code login
  login2({ commit }, msginfo) {
    const { mail, msg } = msginfo
    return new Promise((resolve, reject) => {
      login2({ mail: mail.trim(), msg: msg }).then(response => {
        const { data } = response
        commit('SET_TOKEN', data.access)
        setToken(data.access)
        resolve()
    
      }).catch(error => {
        reject(error)
      })
    })
  },
  // get user info
  getInfo({ commit, state }) {
    return new Promise((resolve, reject) => {
      getInfo(state.token).then(response => {
        const { data } = response

        if (!data) {
          reject('验证失败,重新登陆.')
        }

        const { perms, name, avatar, dept } = data

        // perms must be a non-empty array
        if (!perms || perms.length <= 0) {
          reject('没有任何权限!')
        }
        
        commit('SET_PERMS', perms)
        commit('SET_NAME', name)
        commit('SET_AVATAR', avatar)
        commit('SET_DEPT', dept)
        resolve(data)
      }).catch(error => {
        reject(error)
      })
    })
  },

  // user logout
  logout({ commit, state }) {
    return new Promise((resolve, reject) => {
      logout(state.token).then(() => {
        removeToken() // must remove  token  first
        resetRouter()
        commit('RESET_STATE')
        resolve()
      }).catch(error => {
        reject(error)
      })
    })
  },

  // remove token
  resetToken({ commit }) {
    return new Promise(resolve => {
      removeToken() // must remove  token  first
      commit('RESET_STATE')
      resolve()
    })
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}

